---
title: Firefox 74 for developers
slug: Mozilla/Firefox/Releases/74
tags:
  - '74'
  - Firefox
  - Mozilla
  - Release
---
<p>{{FirefoxSidebar}}</p>

<p class="summary">This article provides information about the changes in Firefox 74 that will affect developers. Firefox 74 was released on March 10, 2020.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<h4 id="Web_console">Web console</h4>

<ul>
 <li>The <code>$x()</code> <a href="/en-US/docs/Tools/Web_Console/Helpers">web console helper</a>'s third argument (result type) now accepts simple string values as well as <a href="/en-US/docs/Web/API/XPathResult#Constants"><code>XPathResult</code> constants</a> (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1602591">bug 1602591</a>).</li>
 <li>Freshly landed support for the optional chaining operator "?." which can also be used with Console's autocomplete (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1594009">bug 1594009</a>).</li>
 <li>The Debugger can now inspect and debug <a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers">nested workers</a> (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1590766">bug 1590766</a>)</li>
</ul>

<h3 id="HTML">HTML</h3>

<p><em>No changes.</em></p>

<h3 id="CSS">CSS</h3>

<ul>
 <li><code><a href="/en-US/docs/Web/CSS/text-underline-position">text-underline-position</a></code> is now enabled by default (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1606997">bug 1606997</a>).</li>
 <li>The <code><a href="/en-US/docs/Web/CSS/text-underline-offset">text-underline-offset</a></code> and <code><a href="/en-US/docs/Web/CSS/text-decoration-thickness">text-decoration-thickness</a></code> properties now accept percentage values (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1607534">bug 1607534</a>).</li>
 <li>The <code>auto</code> value of the {{cssxref("outline-style")}} property has been enabled by default ({{bug(1031664)}}).</li>
</ul>

<h4 id="Removals">Removals</h4>

<ul>
 <li>The <code>-moz-</code> prefixed-<a href="/en-US/docs/Learn/CSS/CSS_layout/Multiple-column_Layout">Multiple-column layout</a> properties have been removed ({{bug(1308636)}}). <a href="https://www.fxsitecompat.dev/en-CA/docs/2020/prefixed-css-multi-column-properties-have-been-removed/">See the Firefox Site Compatibility Notes</a> for more details.</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No changes.</em></p>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The <a href="/docs/Web/JavaScript/Reference/Operators/Optional_chaining">Optional chaining operator</a> has been implemented ({{bug(1566143)}}).</li>
 <li>When a JavaScript URL (<code>javascript:</code>) is evaluated and the result is a string, this string is parsed to create an HTML document, which is then presented. Previously, this document's URL (as reported by the <code><a href="/en-US/docs/Web/API/Document/location">document.location</a></code> property, for example) was the originating <code>javascript:</code> URL; it is now correctly the URL of the document the <code>javascript:</code> URL was evaluated in ({{bug(836567)}}).</li>
</ul>

<h4 id="Removals_2">Removals</h4>

<ul>
 <li>The {{jsxref("Object.toSource()")}} method and the global function {{jsxref("uneval()")}} are no longer available for use by web content or extensions (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1565170">bug 1565170</a>).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="DOM">DOM</h4>

<ul>
 <li>The {{domxref("IDBTransaction.commit()")}} method has been implemented ({{bug(1497007)}}).</li>
</ul>

<h4 id="DOM_events">DOM events</h4>

<ul>
 <li>Firefox 74 now supports the {{domxref("WorkerGlobalScope.languagechange_event", "languagechange_event")}} event and its companion event handler property, {{domxref("WorkerGlobalScope.onlanguagechange", "onlanguagechange")}}, which is triggered when the user changes their preferred language ({{bug(1154779)}}). This was previously listed in our <a href="https://github.com/mdn/browser-compat-data">compatibility database</a> as supported from Firefox 3.5, but this was in error.</li>
</ul>

<h4 id="Canvas_and_WebGL">Canvas and WebGL</h4>

<ul>
 <li>The {{domxref("TextMetrics")}} interface has been extended to contain four more properties measuring the actual bounding box — <code><a href="/en-US/docs/Web/API/TextMetrics/actualBoundingBoxLeft">actualBoundingBoxLeft</a></code>, <code><a href="/en-US/docs/Web/API/TextMetrics/actualBoundingBoxRight">actualBoundingBoxRight</a></code>, <code><a href="/en-US/docs/Web/API/TextMetrics/actualBoundingBoxAscent">actualBoundingBoxAscent</a></code>, and <code><a href="/en-US/docs/Web/API/TextMetrics/actualBoundingBoxDescent">actualBoundingBoxDescent</a></code>. Text metrics can be retrieved using the {{domxref("CanvasRenderingContext2D.measureText()")}} method ({{bug(1102584)}}).</li>
</ul>

<h4 id="Removals_3">Removals</h4>

<ul>
 <li>The non-standard <code>IDBDatabase.mozCreateFileHandle()</code> method has been removed, in favor of the (also non-standard) <code>IDBDatabase.createMutableFile()</code> method ({{bug(1024312)}}).</li>
 <li>The non-standard <code>IDBMutableFile.getFile()</code> method has been removed ({{bug(1607791)}}).</li>
 <li>The non-standard {{domxref("HTMLCanvasElement")}} method {{domxref("HTMLCanvasElement.mozGetAsFile", "mozGetAsFile()")}} has been removed, after being deprecated several years ago ({{bug(1588980)}}).</li>
 <li>The {{domxref("FetchEvent")}} property {{domxref("FetchEvent.isReload", "isReload")}} has been removed, from both Firefox and the specification ({{bug(1264175)}}).</li>
</ul>

<h3 id="HTTP">HTTP</h3>

<ul>
 <li>Feature Policy is now enabled by default! Use the {{HTMLElement("iframe")}} element's {{htmlattrxref("allow", "iframe")}} attribute (and the {{domxref("HTMLIFrameElement")}} property {{domxref("HTMLIFrameElement.allow", "allow")}}) to set permissions for your frames ({{bug(1617219)}}).</li>
 <li>The <code><a href="/en-US/docs/Web/HTTP/Headers/Cross-Origin-Resource-Policy">Cross-Origin-Resource-Policy</a></code> header is now enabled by default (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1602363">bug 1602363</a>).</li>
</ul>

<h3 id="Security">Security</h3>

<ul>
 <li>TLS 1.0 and 1.1 support has been removed from Firefox; you'll need to make sure your web server supports TLS 1.2 or 1.3 going forward. From now on, Firefox will return a <a href="https://support.mozilla.org/en-US/kb/secure-connection-failed-firefox-did-not-connect">Secure Connection Failed</a> error when connecting to servers using the older TLS versions ({{bug(1606734)}}).</li>
</ul>

<h3 id="Plugins">Plugins</h3>

<p><em>No changes.</em></p>

<h3 id="Security_2">Security</h3>

<ul>
 <li>Starting in Firefox 74, when a site delegates permission to access a resource to embedded content in an {{HTMLElement("iframe")}} using the {{htmlattrxref("allow", "iframe")}} attribute, and the embedded page requests permission to use that resource, the parent page prompts the user for permission to use the resource and share it with the embedded domain, rather than both the outer and inner pages prompting the user for permission. If the outer page doesn't have the permission requested by the <code>allow</code> attribute, the <code>&lt;iframe&gt;</code> is immediately denied access without prompting the user {{bug(1483631)}}.</li>
</ul>

<h3 id="WebDriver_conformance_Marionette">WebDriver conformance (Marionette)</h3>

<ul>
 <li>Added <code>WebDriver:Print</code> to print the current page as a PDF document ({{bug(1604506)}}).</li>
 <li><code>Webdriver:TakeScreenshot</code> now always captures the top-level browsing context and not the currently-selected browsing context, if no element to capture has been specified ({{bug(1398087)}}, {{bug(1606794)}}).</li>
 <li>Using <code>Webdriver:TakeScreenshot</code>'s <code>full</code> argument causes the complete page to be captured ({{bug(1571424)}}).</li>
</ul>

<h2 id="Changes_for_add-on_developers">Changes for add-on developers</h2>

<h3 id="API_changes">API changes</h3>

<ul>
 <li>Shortcut keys can now be unassigned in {{WebExtAPIRef("Commands.update")}} by passing an empty value of <code>shortcut</code> {{bug(1475043)}}.</li>
 <li><code>urlclassification</code>s are now returned as part of the <code>details</code> in each event of {{WebExtAPIRef("webrequest")}}, providing information on whether a request is classified as fingerprinting or tracking {{bug(1589494)}}.</li>
</ul>

<h3 id="Manifest_changes">Manifest changes</h3>

<p><em>No changes.</em></p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Hacks blog post: <a href="https://hacks.mozilla.org/2020/03/security-means-more-with-firefox-74-2/">Security means more with Firefox 74</a></li>
 <li><a href="https://www.fxsitecompat.com/en-CA/versions/74/">Site compatibility for Firefox 74</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(73)}}</p>
